// Craig S. Kaplan
//
// Another noise demo that we didn't talk about in class.  
// Use the noise() function to construct a 3D terrain.
// Look in the keyPressed() hook below to see all the key
// controls you can use to operate this sketch.

// You are not required to understand how to do the 3D part
// of this sketch yourself, but it's useful if you want to
// play around with 3D on your own.

import peasy.*;

int sz = 256;

float water = 100.0;
float scaling = 0.1;
float hscale = 100.0;
float phase = 0.0;

PeasyCam cam;

void setup()
{
  size( 600, 600, P3D );

  cam = new PeasyCam( this, 50 );
  cam.lookAt( 128, 0, 128 );
}

void draw()
{
  if ( keyPressed ) {
    if ( key == ',' ) {
      scaling = scaling * 0.95;
    } else if ( key == '.' ) {
      scaling = scaling / 0.95;
    } else if ( key == 'z' ) {
      water += 3.0;
    } else if ( key == 'x' ) {
      water -= 3.0;
    } else if( key == 'a' ) {
      hscale = hscale * 0.95;
    } else if( key == 's' ) {
      hscale = hscale / 0.95;
    } else if( key == 'q' ) {
      phase += 0.1;
    } else if( key == 'w' ) {
      phase -= 0.1;
    }
  }
  background( 50 );
  fill( 200 );
  lights();
  noStroke();

  beginShape( TRIANGLES );
  for ( int y = 0; y < sz; ++y ) {
    for ( int x = 0; x < sz; ++x ) {
      float tl = hscale*noise( x*scaling, y*scaling, phase*scaling );
      float tr = hscale*noise( (x+1)*scaling, y*scaling, phase*scaling );
      float bl = hscale*noise( x*scaling, (y+1)*scaling, phase*scaling );
      float br = hscale*noise( (x+1)*scaling, (y+1)*scaling, phase*scaling );

      fill( #2CA23B );

      vertex( x, tl, y );
      vertex( x, bl, y+1 );
      vertex( x + 1, tr, y );

      vertex( x + 1, tr, y );
      vertex( x, bl, y+1 );
      vertex( x+1, br, y+1 );
    }
  }
  endShape();

  fill( 160, 160, 255 );
  beginShape( QUADS );
  vertex( 0.0, water, 0.0 );
  vertex( sz, water, 0.0 );
  vertex( sz, water, sz );
  vertex( 0.0, water, sz );
  endShape();
}